/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.email.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class EmailLayoutUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final java.lang.String bezeichnung;

    public java.lang.String getBezeichnung(){
      return bezeichnung;
    }


  public EmailLayoutUK(
java.lang.String bezeichnung
  ) {
    super();


      this.bezeichnung = bezeichnung;
      }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((bezeichnung == null) ? 0 : bezeichnung.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            EmailLayoutUK other = (EmailLayoutUK) obj;

                if (bezeichnung == null) {
          if (other.bezeichnung != null) {
            return false;
          }
        } else if (!bezeichnung.equals(other.bezeichnung)) {
          return false;
        }
        
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return EmailLayoutConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(EmailLayoutConstants.MESSAGE_KEY_ENTITY_EINZAHL, EmailLayoutConstants.MESSAGE_KEY_BEZEICHNUNG_EINZAHL, bezeichnung));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "EmailLayoutUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"bezeichnung="+bezeichnung
                                    ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(bezeichnung);
     return list;
   }

            public static <E extends EmailLayout> java.util.Map<EmailLayoutUK, E> mappeEmailLayoutNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(EmailLayout::getEmailLayoutUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<EmailLayout, EmailLayoutUK> getEmailLayoutToUKFunction() {
                return EmailLayout::getEmailLayoutUK;
                }

}
